#!/usr/bin/perl

$GROUP_RPM       = "./N8100-1559_N8100-1560_UpdateModule-1.12.tgz";
$LOG_FILE        = "./patch01-12.log";
$FILELIST        = "./InstallFileList.txt";
$UPDATE_NAME 	 = "N8100-1559_N8100-1560_UpdateModule-1.12";

open(FH, $FILELIST);
@RPMINSTALLLIST = <FH>;
close(FH);

$BIND_RPM        = "bind-9.2.4-41.i386.rpm";
$BIND_ENT        = "bind-9.2.4-41";
$BIND_CHROOT_RPM = "bind-chroot-9.2.4-41.i386.rpm";

#$OPENLDAP_S_RPM  = "openldap-servers-2.2.13-8.el4_6.5.i386.rpm";
#$OPENLDAP_ENT    = "openldap-2.2.13-8.el4_6.5";

#$SAMBA_COM_RPM   = "samba-common-3.0.33-0.35.el4.i386.rpm";
#$SAMBA_ENT       = "samba-3.0.33-0.35.el4.i386.rpm";
#$APACHE_RPM = "httpd-2.0.52-49.ent.i386.rpm";

print "\n---Script Start-----\n\n";
system("echo '---Script Start-----' >> $LOG_FILE");
system("/bin/date >> $LOG_FILE");

#if(!-e $GROUP_RPM){
#  print "No such file : $GROUP_RPM\n";
#  system("echo 'No such file : $GROUP_RPM' >> $LOG_FILE");
#  exit 1;
#}

#if(!open(IN,"/bin/tar -xzf $GROUP_RPM |")){
#  print "$GROUP_RPM Decompression Failed.\n";
#  system("echo '$GROUP_RPM Decompression Failed.' >> $LOG_FILE");
#  exit 1;
#}
#close(IN);

@HB_fileP=();
if($ARGV[0] eq ""){
	&prescripts();
#        system("/bin/sh ../scripts/webmail-httpd-mod_ssl-2.0.52-47.ent.pre.sh 2>/dev/null 1> /dev/null");
#	system("/bin/sh ../scripts/webmail-x-4.0.21-1.pre.sh 2>/dev/null 1> /dev/null");
	&AllInstall();
#	&witchyinstall();
	&upscripts();
	&version_rewrite();

}
#elsif($ARGV[0] eq "-D"){
# if(-d "./$UPDATE_NAME"){
#   system("/bin/rm -rf ./$UPDATE_NAME > /dev/null 2>&1");
#   print "Delete Sccessful.(./$UPDATE_NAME)\n";
# }
#}
else{
	print "Invalid Option.";
	system("echo 'Invalid Option' >> $LOG_FILE");
}

#if(-d "./$UPDATE_NAME"){
#  system("/bin/rm -rf ./$UPDATE_NAME > /dev/null 2>&1");
#}

system("/bin/rpm -qa >> $LOG_FILE");
system("/bin/date >> $LOG_FILE");
print "\n---Script End-----\n";
system("echo '---Script End-----' >> $LOG_FILE");
exit 0;


sub AllInstall
{
	local($rpmname) = "";
	local(@LS_fileP) = ();
	local(@code) = ();

#  if(!-e $FILELIST){
#    print "No such file : $FILELIST\n";
#    system("echo 'No such file :$FILELIST' >> $LOG_FILE");
#    return;
#  }

#  &readFile($FILELIST,*LS_fileP);

	foreach $rpmname (@RPMINSTALLLIST){
		$rpmname =~ s/^\s*//;
		$rpmname =~ s/\s*$//;

		if(!-e "../rpms/$rpmname"){
			print "No such file : $rpmname\n";
			system("echo 'No such file : $rpmname' >> $LOG_FILE");
			return;
		}
	}

	foreach $rpmname (@RPMINSTALLLIST){
		$rpmname =~ s/^\s*//;
		$rpmname =~ s/\s*$//;

		if($rpmname eq "$APACHE_RPM"){
			&ApacheInstall($rpmname);

			if(-e "/etc/httpd/conf/httpd.conf.rpmnew"){
				system("/bin/rm /etc/httpd/conf/httpd.conf.rpmnew > /dev/null 2>&1");
			}
		}
		elsif($rpmname eq "$APACHE_S_RPM"){
			if(!open(IN,"/bin/rpm -qq $HTTP_ENT 2>&1 |")){
				print "Error Update.($rpmname)\n";
				system("echo 'Error Update.($rpmname)' >> $LOG_FILE");
				return;
			}
			@code = ();
			@code = <IN>;
			close(IN);

			if($code[0] =~ /package\s+(.+)\s+is\s+not\s+installed/){
				print "Error Update.($rpmname)\n";
				system("echo 'Error Update.($rpmname)' >> $LOG_FILE");
				return;
			}

			UpdateRPM($rpmname);
			system("/bin/chmod u-s /usr/sbin/suexec &> /dev/null");
		}
		elsif($rpmname eq "$MODSSL_RPM"){
			$APACHE_RPM =~ /(.*)\..*\.rpm$/ ;
			$APACHE_VER = $1;
			if(!open(IN,"/bin/rpm -qq $APACHE_VER 2>&1 |")){
				print "Error Update.($rpmname)\n";
				system("echo 'Error Update.($rpmname)' >> $LOG_FILE");
				next;
			}
			close(IN);
			UpdateRPM($rpmname);
		}
		elsif($rpmname eq "$BIND_RPM"){
			UpdateRPM($rpmname);

			if(-e "/etc/rndc.key.rpmnew"){
				system("/bin/rm /etc/rndc.key.rpmnew > /dev/null 2>&1");
			}

			system("/bin/chmod 770 /var/named > /dev/null 2>&1");
		}
		elsif($rpmname eq "$BIND_CHROOT_RPM"){
			if(!open(IN,"/bin/rpm -qq $BIND_ENT 2>&1 |")){
				print "Error Update.($rpmname)\n";
				system("echo 'Error Update.($rpmname)' >> $LOG_FILE");
				return;
			}
			@code = ();
			@code = <IN>;
			close(IN);
			if($code[0] =~ /package\s+(.+)\s+is\s+not\s+installed/){
				print "Error Update.($rpmname)\n";
				system("echo 'Error Update.($rpmname)' >> $LOG_FILE");
				return;
			}

			UpdateRPM($rpmname);

			if(-e "/etc/named.conf.rpmsave"){
				system("/bin/rm /etc/named.conf.rpmsave > /dev/null 2>&1");
			}

			if(-e "/var/named/chroot/etc/named.conf.rpmsave"){
				system("/bin/rm /var/named/chroot/etc/named.conf.rpmsave > /dev/null 2>&1");
			}

			system("/bin/chown -f --from=root:named named:named /var/named/chroot/var/named > /dev/null 2>&1");
			system("/bin/chmod 770 /var/named/chroot/var/named > /dev/null 2>&1");
		}
		elsif($rpmname eq "$LIBGL_RPM"){
			InstallRPM($rpmname);
		}
		elsif($rpmname eq "$LIBS_RPM"){
			InstallRPM($rpmname);
		}
		elsif($rpmname eq "$OPENLDAP_S_RPM"){
			if(!open(IN,"/bin/rpm -qq $OPENLDAP_ENT 2>&1 |")){
				print "Error Update.($rpmname)\n";
				system("echo 'Error Update.($rpmname)' >> $LOG_FILE");
				return;
			}
			@code = ();
			@code = <IN>;
			close(IN);

			if($code[0] =~ /package\s+(.+)\s+is\s+not\s+installed/){
				print "Error Update.($rpmname)\n";
				system("echo 'Error Update.($rpmname)' >> $LOG_FILE");
				return;
			}

			UpdateRPM($rpmname);

			if(-e "/etc/openldap/slapd.conf.rpmnew"){
				system("/bin/rm /etc/openldap/slapd.conf.rpmnew > /dev/null 2>&1");
			}
		}
		elsif($rpmname eq "$SAMBA_COM_RPM"){
			if(!open(IN,"/bin/rpm -qq $SAMBA_ENT 2>&1 |")){
				print "Error Update.($rpmname)\n";
				system("echo 'Error Update.($rpmname)' >> $LOG_FILE");
				return;
			}
			@code = ();
			@code = <IN>;
			close(IN);

			if($code[0] =~ /package\s+(.+)\s+is\s+not\s+installed/){
				print "Error Update.($rpmname)\n";
				system("echo 'Error Update.($rpmname)' >> $LOG_FILE");
				return;
			}

			UpdateRPM($rpmname);

			if(-e "/etc/samba/smb.conf.rpmnew"){
				system("/bin/rm /etc/samba/smb.conf.rpmnew > /dev/null 2>&1");
			}
		}
		elsif($rpmname eq "$SYSINIT_RPM"){
			if(UpdateRPM($rpmname) == 0){
				if(-e "/etc/rc.d/rc.sysinit.rpmsave"){
					system("/bin/rm /etc/rc.d/rc.sysinit.rpmsave > /dev/null 2>&1");
				}
			}
		}
		elsif($rpmname eq $INSTALL_RPM1){

			&InstallRPM($rpmname);
		}elsif ($rpmname eq $INSTALL_RPM2){
			&InstallRPM($rpmname);
		}elsif (($rpmname eq $INSTALL_RPM3) || ($rpmname eq $INSTALL_RPM4)){
                        &InstallRPM($rpmname);
                }
		else{
			UpdateRPM($rpmname);
		}
	}
}

sub UpdateRPM
{
	local($rpmname) = @_;
	local($shortname) = "";
	local(@code) = ();

	$shortname=Judge_RPM($rpmname);

	if(!open(IN,"LANG= /bin/rpm -qq $shortname 2>&1 |")){
		print "Update Failed.($rpmname)\n";
		system("echo 'Update Failed.($rpmname)' >> $LOG_FILE");
		return 1;
	}
	@code = <IN>;
	close(IN);

#	if($code[0] =~ /package\s+(.+)\s+is\s+not\s+installed/){
#    print "Package $rpmname is not installed.\n";
#		return 0;
#	}

	if(!open(IN,"/bin/rpm -U --nodeps --force ../rpms/$rpmname > /dev/null 2>&1 |")){
		print "Update Failed.($rpmname)\n";
		system("echo 'Update Failed.($rpmname)' >> $LOG_FILE");
		return 1;
	}
	close(IN);

	print "Update Successful.($rpmname)\n";
	system("echo 'Update Successful.($rpmname)' >> $LOG_FILE");
	return 0;
}

sub InstallRPM
{
	local($rpmname) = @_;
	if(!open(IN,"/bin/rpm -U --force --nodeps ../rpms/$rpmname > /dev/null 2>&1 |")){
		print "Install Failed.($rpmname)\n";
		system("echo 'Install Failed.($rpmname)' >> $LOG_FILE");
		return 1;
	}
	close(IN);
	print "Install Successful.($rpmname)\n";
	system("echo 'Install Successful.($rpmname)' >> $LOG_FILE");
	return 0;
}

sub ApacheInstall
{
	local($rpmname) = @_;
	local($i,$j) = "";
	local(@HC_fileP,@RA_fileP,@HC_fileP,@code) = ();

	$HTTPDCONF      = "/etc/httpd/conf/httpd.conf";
	$ROTATE_APACHE  = "/etc/logrotate.d/apache";
	$ROTATE_HTTPD   = "/etc/logrotate.d/httpd";

	if(!-e $HTTPDCONF){
		print "No such file : $HTTPDCONF\n";
		system("echo 'No such file :$HTTPDCONF' >> $LOG_FILE");
	}

##==========================
## ReadFile : $HTTPDCONF
##==========================
	@HC_fileP=();
	&readFile($HTTPDCONF,*HC_fileP);

	foreach(@HC_fileP){
		if(/^\s*\#/){
			next;
		}
		elsif(/^\s*Timeout\s+(.+)\s+$/i){
			$key{'TIMEOUT'}  = $1;
		}
		elsif(/^\s*MinSpareServers\s+(.+)\s+$/i){
			$key{'MINSPARE'} = $1;
		}
		elsif(/^\s*MaxSpareServers\s+(.+)\s+$/i){
			$key{'MAXSPARE'} = $1;
		}
		elsif(/^\s*StartServers\s+(.+)\s+$/i){
			$key{'STARTS'} = $1;
		}
		elsif(/^\s*MaxClients\s+(.+)\s+$/i){
			$key{'MAXCL'} = $1;
		}
		elsif(/^\s*User\s+(.+)\s+$/i){
			$key{'USER'} = $1;
		}
		elsif(/^\s*Group\s+(.+)\s+$/i){
			$key{'GROUP'} = $1;
		}
		elsif(/^\s*ServerName\s+(.+)\s+$/i){
			$key{'SVNAME'} = $1;
		}
		elsif(/^\s*ServerAdmin\s+(.+)\s+$/i){
			$key{'SVADMIN'} = $1;
		}
		elsif(/^\s*Include\s+(.+)\s+$/i){
			push(@inc,"Include $1\n");
		}
		elsif(/^\s*Port\s+(.+)\s+$/i){
			$key{'PORT'} = $1;
		}
		elsif(/^\s*ServerTokens\s+(.+)\s+$/i){
			$key{'ServerTokens'} = $1;
		}
	}
#	if(!$key{"SVADMIN"}){
#	  $key{"SVADMIN"} = "web@".$key{"SVNAME"};
#	}

##========================
## Read : $ROTATE_APACHE
##========================
	@RA_fileP=();
	&readFile($ROTATE_APACHE,*RA_fileP);

##====================
## Update : Apache
##====================
	if(!open(IN,"/bin/rpm -qq $HTTP_ENT 2>&1 |")){
		print "Error Update.($rpmname)\n";
		system("echo 'Error Update.($rpmname)' >> $LOG_FILE");
		return;
	}
	@code = ();
	@code = <IN>;
	close(IN);

#	if($code[0] !~ /package\s+(.+)\s+is\s+not\s+installed/){
#	  print "Package $rpmname is already installed\n";
#	  return;
#	}
	if(!open(IN,"/bin/rpm -U --nodeps --force ../rpms/$rpmname > /dev/null 2>&1 |")){
#    print "Failed to Update.($rpmname)\n";
		system("echo 'Update Failed.($rpmname)' >> $LOG_FILE");
		return;
	}
	close(IN);

#	system("/bin/chmod u-s /usr/sbin/suexec &> /dev/null");

##================================
## Substitution : $ROTATE_APACHE
##================================
	if(-e '/etc/logrotate.d/httpd') {
		unlink('/etc/logrotate.d/httpd');
	}

##============================
## Substitution : $HTTPDCONF
##============================
	@HC_fileP=();
	&readFile($HTTPDCONF,*HC_fileP);

	for($i=0;$i<@HC_fileP;$i++){
		if($HC_fileP[$i] =~ /^\s*\#/){
			next;
		}
		elsif($HC_fileP[$i] =~ /^\s*Timeout\s+/i){
			splice(@HC_fileP,$i,1,"Timeout $key{'TIMEOUT'}\n");
		}
		elsif($HC_fileP[$i] =~ /^\s*MinSpareServers\s+/i){
			splice(@HC_fileP,$i,1,"MinSpareServers $key{'MINSPARE'}\n");
		}
		elsif($HC_fileP[$i] =~ /^\s*MaxSpareServers\s+/i){
			splice(@HC_fileP,$i,1,"MaxSpareServers $key{'MAXSPARE'}\n");
		}
		elsif($HC_fileP[$i] =~ /^\s*StartServers\s+/i){
			splice(@HC_fileP,$i,1,"StartServers $key{'STARTS'}\n");
		}
		elsif($HC_fileP[$i] =~ /^\s*MaxClients\s+/i){
			splice(@HC_fileP,$i,1,"MaxClients $key{'MAXCL'}\n");
		}
		elsif($HC_fileP[$i] =~ /^\s*User\s+/i){
			splice(@HC_fileP,$i,1,"User $key{'USER'}\n");
		}
		elsif($HC_fileP[$i] =~ /^\s*Group\s+/i){
			splice(@HC_fileP,$i,1,"Group $key{'GROUP'}\n");
		}
		elsif($HC_fileP[$i] =~ /^\s*ServerName\s+/i){
			splice(@HC_fileP,$i,1,"ServerName $key{'SVNAME'}\n");
		}
		elsif($HC_fileP[$i] =~ /^\s*ServerAdmin\s+/i){
			splice(@HC_fileP,$i,1,"ServerAdmin $key{'SVADMIN'}\n");
		}
		elsif($HC_fileP[$i] =~ /^Listen\s*80\s+/i){
			splice(@HC_fileP,$i,1,"#Listen 80\n");
		}
		elsif($HC_fileP[$i] =~ /^Listen\s*443\s+/i){
			splice(@HC_fileP,$i,1,"#Listen 443\n");
		}
		elsif($HC_fileP[$i] =~ /^\s*Port\s+/i){
			splice(@HC_fileP,$i,1,"Port $key{'PORT'}\n");
		}
		elsif($HC_fileP[$i] =~ /^\s*ServerTokens\s+/i){
			if($key{'ServerTokens'} =~ /OS/){
				splice(@HC_fileP,$i,1,"ServerTokens ProductOnly\n");
			}
			else{
				splice(@HC_fileP,$i,1,"ServerTokens $key{'ServerTokens'}\n");
			}
		}
		elsif($HC_fileP[$i] =~ /^\s*DocumentRoot\s+\"*\/home\/httpd\/html\"*/i) {
			$HC_fileP[$i] = "DocumentRoot \"/home/web/public_html\"\n";
	}
	elsif ($HC_fileP[$i] =~ /^\s*<\s*Directory\s+\"*\/home\/httpd\/html\"*\s*>/i) {
		$HC_fileP[$i] = "<Directory \"/home/web/public_html\">\n";
	}

	elsif($HC_fileP[$i] =~ /^\s*Include\s+(.+)\s+$/i){
		for($j=0;$j<@inc;$j++){
			if($HC_fileP[$i] eq $inc[$j]){
				splice(@inc,$j,1);
				$j--;
			}
		}
	}

	}
	push(@HC_fileP,@inc);
	&writeFile($HTTPDCONF,*HC_fileP);
	print "httpd_Update Successful.($rpmname)\n";
	system("echo 'httpd_Update Successful.($rpmname)' >> $LOG_FILE");

	return;
}

sub Judge_RPM
{
	local($rpmname) = @_;
	local(@code) = ();

	if(!open(IN,"/bin/rpm -qip ../rpms/$rpmname |")){
		print "Existence check failed.($rpmname)\n";
		system("echo 'Existence check failed.($rpmname)' >> $LOG_FILE");
		return "";
	}
	@code=<IN>;
	@ent = split(/\s+/,$code[0]);
	return ($ent[2]);

}

sub readFile
{
	local($filename,*fileP) = @_;

	if(open(IN,"$filename")){
		@fileP = <IN>;
		close (IN);
	}

}

sub writeFile
{
	local($filename,*fileP) = @_;

	if(open(OUT,"> $filename")){
		print(OUT @fileP);
		close(OUT);
	}
}

sub witchyinstall{

	open(IN, "rpm -q witchymail |");
	@cmd = <IN>;
	close(IN);

	foreach $cmdl (@cmd) {
		if ($cmdl =~ /imap/){
			system("rm -rf ../scripts/webmail-x-4.0.23-1.wi-pop.i386.rpm");
			system("mv  ../scripts/webmail-x-4.0.23-1.wi-imap.i386.rpm ../scripts/witchymail-4.0.23-1.imap.i386.rpm");
			system("rpm -Uvh --nodeps --force ../scripts/witchymail-4.0.23-1.imap.i386.rpm");
		}elsif ($cmdl =~ /pop/){
			system("rm -rf ../scripts/webmail-x-4.0.23-1.wi-imap.i386.rpm");
			system("mv ../scripts/webmail-x-4.0.23-1.wi-pop.i386.rpm ../scripts/witchymail-4.0.23-1.pop.i386.rpm");
			system("rpm -Uvh --nodeps --force ../scripts/witchymail-4.0.23-1.pop.i386.rpm");
		}
	}
#############################################################################
#wml_monitor.sh comment out 
#############################################################################

	system("su witchymail -c  /home/witchymail/wm_current/sbin/wms_license.batch > /dev/null 2>&1");
	system("/bin/sh ../scripts/config-mw-1.0-0.2.post.sh  2>/dev/null 1> /dev/null");

	open(IN, "rpm -qi witchymail |");
	@cmd = <IN>;
	close(IN);

}

sub prescripts {
   # system("/bin/sh ../scripts/webmail-httpd-mod_ssl-2.0.52-49.ent.pre.sh 2>/dev/null 1> /dev/null");
   # system("/bin/sh ../scripts/webmail-x-4.0.23-1.pre.sh 2>/dev/null 1> /dev/null");
}

sub upscripts {
    #    system("/bin/sh ../scripts/config-mw-1.0-0.2.post.sh  2>/dev/null 1> /dev/null");
    #	system("/bin/sh ../scripts/httpd-2.0.52-49.ent.post.sh  2>/dev/null 1> /dev/null");
    #	system("/bin/sh ../scripts/webmail-httpd-mod_ssl-2.0.52-49.ent.post.sh  2>/dev/null 1> /dev/null");
    #	system("/bin/sh ../scripts/webmail-x-4.0.23-1.post.sh 2>/dev/null 1> /dev/null");
}

sub version_rewrite{

	my $reptgz = "MWN8100-1559_N8100-1560-1.12.rep.tgz";
	my $release = "1.12";


########################################################
	if (!&readFile("/etc/opt/nec/N-code", "ncode", *ncode)) {
		&showErrorPage("機種情報の取得に失敗しました。", "index.cgi");
		exit(1);
	}
###

	open(NCODEFILE,"/etc/opt/nec/N-code");
	my @ncodetemp = <NCODEFILE>;
	close(NCODEFILE);


	my $expid = $ncodetemp[0];
	$expid =~ s/\n//;
        $expid =~ s/\0.*//;

	my $expdatfile2 = "../dat/";
	$expdatfile2 .=  $expid;
	$expdatfile2 .= "_online_update.dat";

	open(EXPDATLO, $expdatfile2);
	my @expdatfile = <EXPDATLO>;
	close(EXPDATLO);
	
	system("mkdir -p /var/opt/nec/wbmc/olud/dat/ 2>/dev/null 1> /dev/null");
	my @allexpdatfile;
	my $allexpdatfile2 = "/var/opt/nec/wbmc/olud/dat/".$expid."_online_update.dat";

	if (-e $allexpdatfile2){

		open(ALLEXPDAT,$allexpdatfile2);
		@allexpdatfile = <ALLEXPDAT>;
		close(ALLEXPDAT);
	}
	my @listmodule = ();
	foreach my $allexpdatline (@allexpdatfile){
		if ($allexpdatline =~ /\S*UpdateModule-(\S+).mod/){
			push(@listmodule,$allexpdatline);
		}
	}
	foreach my $expdatline (@expdatfile){
		if ($expdatline =~ /\S*\s*:\s*(\S*.mod)/){
			my $expdatmod = $1;
			my $listmodan = grep(/$expdatmod/,@listmodule);
			if ($listmodan < 1){
				push(@listmodule,$expdatline);
			}
		}
	}
	my @listmoduletemp = ();
	my %modhs;
	foreach my $modtemp (@listmodule){
		my $modtempnum;
		if ($modtemp =~ /\S*UpdateModule-(\S+).mod/){
			$modtempnum = $1;
			$modhs{$modtempnum} =  $modtemp;
		}
	}
	my @listmodfi = ();
	push (@listmodfi,"\%modules");
	push (@listmodfi,"\n");
	for my $modkey (sort {$a <=> $b} keys %modhs) {
		my $modtemp3 = $modhs{$modkey};
		push (@listmodfi,$modtemp3);
	}

	open(OUT,"> $allexpdatfile2");
	foreach $t4 (@listmodfi){
	print OUT $t4;
	}
	close(OUT); 

####rep ########################################################
	system("cp ../rep/*  /var/opt/nec/wbmc/olud/dat/ 2>/dev/null 1> /dev/null");
	system("tar xzf ../rep/$reptgz -C /var/opt/nec/wbmc/olud/dat/  2>/dev/null 1> /dev/null");

	$versionfile="/etc/opt/nec/wbmc/updateVersion";

	if (! -e $versionfile)
	{
		system("/bin/echo 'Release: 0.0' > $versionfile");
	}
	system("/bin/echo 'Release: $release '  > $versionfile");

}

